/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.uytube.ui.categoria;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;
import javax.swing.JTextField;
import javax.swing.RowFilter;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableRowSorter;
import org.uytube.controladores.Fabrica;
import org.uytube.controladores.ICategoria;
import org.uytube.datatypes.DtListaProp;
import org.uytube.datatypes.DtVideoProp;

/** @author toto */
public class ConsultaCategoria extends javax.swing.JInternalFrame {

  private final ICategoria iCategoria = Fabrica.getControllerOf(Fabrica.Controller.CATEOGRIA);
  private final DefaultTableModel modeloCategorias =
      new DefaultTableModel() {
        @Override
        public boolean isCellEditable(int row, int column) {
          return false;
        }
      };

  private final DefaultTableModel modeloVideos =
      new DefaultTableModel() {
        @Override
        public boolean isCellEditable(int row, int column) {
          return false;
        }
      };

  private final DefaultTableModel modeloListas =
      new DefaultTableModel() {
        @Override
        public boolean isCellEditable(int row, int column) {
          return false;
        }
      };

  private final TableRowSorter<DefaultTableModel> rowSorterCategorias =
      new TableRowSorter<>(modeloCategorias);

  private void registerFilter(
      JTextField txtField, TableRowSorter<DefaultTableModel> rowSorterVideo) {
    txtField
        .getDocument()
        .addDocumentListener(
            new DocumentListener() {
              @Override
              public void insertUpdate(DocumentEvent e) {
                find();
              }

              @Override
              public void removeUpdate(DocumentEvent e) {
                find();
              }

              @Override
              public void changedUpdate(DocumentEvent e) {
                find();
              }

              private void find() {
                String text = txtField.getText();
                if (text.trim().length() == 0) {
                  rowSorterVideo.setRowFilter(null);
                } else {
                  rowSorterVideo.setRowFilter(RowFilter.regexFilter("(?i)" + Pattern.quote(text)));
                }
              }
            });
  }

  private void initTblCategorias() {
    modeloCategorias.addColumn("Nombre");
    tblCategorias.setModel(modeloCategorias);
    tblCategorias.setRowSorter(rowSorterCategorias);
    tblCategorias
        .getSelectionModel()
        .addListSelectionListener(
            event -> {
              /*cargar datos en tabla de listas*/
              if (!event.getValueIsAdjusting() && tblCategorias.getSelectedRow() >= 0) {
                btnSiguiente.setEnabled(true);
                btnSiguiente.setBackground(new Color(0, 123, 64));
              }
            });

    registerFilter(txtFindCategoria, rowSorterCategorias);
  }

  private void initTblVideos() {
    modeloVideos.addColumn("Nombre");
    modeloVideos.addColumn("Propietario");
    tblVideos.setModel(modeloVideos);
  }

  private void initTblListas() {
    modeloListas.addColumn("Nombre");
    modeloListas.addColumn("Propietario");
    tblListas.setModel(modeloListas);
  }

  /** Creates new form ConsultaCategoria */
  public ConsultaCategoria() {
    initComponents();
    btnSiguiente.setEnabled(false);
    btnSiguiente.setBackground(Color.GRAY);
    initTblCategorias();
    initTblListas();
    initTblVideos();
    List<String> categorias = iCategoria.listarCategorias();
    for (String categoria : categorias) {
      modeloCategorias.addRow(new Object[] {categoria});
    }
    panel2.setVisible(false);
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT
   * modify this code. The content of this method is always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    panel1 = new javax.swing.JPanel();
    jLabel16 = new javax.swing.JLabel();
    jSeparator15 = new javax.swing.JSeparator();
    txtFindCategoria = new javax.swing.JTextField();
    jLabel13 = new javax.swing.JLabel();
    jSeparator16 = new javax.swing.JSeparator();
    jScrollPane6 = new javax.swing.JScrollPane();
    tblCategorias = new javax.swing.JTable();
    btnSiguiente = new javax.swing.JButton();
    panel2 = new javax.swing.JPanel();
    lblTitle1 = new javax.swing.JLabel();
    jSeparator1 = new javax.swing.JSeparator();
    btnVolver = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    tblListas = new javax.swing.JTable();
    lblTitle2 = new javax.swing.JLabel();
    jSeparator2 = new javax.swing.JSeparator();
    jScrollPane2 = new javax.swing.JScrollPane();
    tblVideos = new javax.swing.JTable();
    jPanel1 = new javax.swing.JPanel();
    jLabel9 = new javax.swing.JLabel();
    jLabel8 = new javax.swing.JLabel();
    jLabel7 = new javax.swing.JLabel();
    lblTitle = new javax.swing.JLabel();

    setClosable(true);
    setIconifiable(true);
    setTitle("Consulta Categoria");
    getContentPane().setLayout(null);

    panel1.setBackground(new java.awt.Color(255, 255, 255));
    panel1.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    panel1.setLayout(null);

    jLabel16.setFont(new java.awt.Font("Monospaced", 1, 14)); // NOI18N
    jLabel16.setForeground(new java.awt.Color(33, 33, 33));
    jLabel16.setText("Seleccionar Categoria");
    panel1.add(jLabel16);
    jLabel16.setBounds(20, 30, 180, 20);
    panel1.add(jSeparator15);
    jSeparator15.setBounds(20, 50, 430, 10);

    txtFindCategoria.setForeground(new java.awt.Color(60, 63, 65));
    txtFindCategoria.setBorder(
        javax.swing.BorderFactory.createTitledBorder(
            javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1),
            "Buscar categoria:",
            javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
            javax.swing.border.TitledBorder.DEFAULT_POSITION,
            new java.awt.Font("Monospaced", 0, 12))); // NOI18N
    panel1.add(txtFindCategoria);
    txtFindCategoria.setBounds(53, 75, 135, 40);

    jLabel13.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/search.png"))); // NOI18N
    panel1.add(jLabel13);
    jLabel13.setBounds(30, 87, 24, 24);
    panel1.add(jSeparator16);
    jSeparator16.setBounds(55, 112, 135, 10);

    tblCategorias.setModel(
        new javax.swing.table.DefaultTableModel(
            new Object[][] {{null}, {null}, {null}, {null}}, new String[] {"Nombre"}));
    tblCategorias.setSelectionBackground(new java.awt.Color(66, 58, 111));
    tblCategorias.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane6.setViewportView(tblCategorias);

    panel1.add(jScrollPane6);
    jScrollPane6.setBounds(40, 130, 390, 220);

    btnSiguiente.setBackground(new java.awt.Color(0, 123, 64));
    btnSiguiente.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnSiguiente.setForeground(new java.awt.Color(255, 255, 255));
    btnSiguiente.setText("Siguiente");
    btnSiguiente.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnSiguiente.setContentAreaFilled(false);
    btnSiguiente.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnSiguiente.setOpaque(true);
    btnSiguiente.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnSiguienteMouseClicked(evt);
          }
        });
    panel1.add(btnSiguiente);
    btnSiguiente.setBounds(340, 390, 110, 40);

    getContentPane().add(panel1);
    panel1.setBounds(30, 90, 480, 460);

    panel2.setBackground(new java.awt.Color(255, 255, 255));
    panel2.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    panel2.setLayout(null);

    lblTitle1.setFont(new java.awt.Font("Monospaced", 0, 20)); // NOI18N
    lblTitle1.setForeground(new java.awt.Color(53, 12, 87));
    lblTitle1.setText("Listas");
    panel2.add(lblTitle1);
    lblTitle1.setBounds(200, 220, 80, 20);
    panel2.add(jSeparator1);
    jSeparator1.setBounds(20, 250, 440, 10);

    btnVolver.setBackground(new java.awt.Color(51, 89, 245));
    btnVolver.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnVolver.setForeground(new java.awt.Color(255, 255, 255));
    btnVolver.setText("Volver");
    btnVolver.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnVolver.setContentAreaFilled(false);
    btnVolver.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnVolver.setOpaque(true);
    btnVolver.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnVolverMouseClicked(evt);
          }
        });
    panel2.add(btnVolver);
    btnVolver.setBounds(30, 405, 110, 40);

    tblListas.setModel(
        new javax.swing.table.DefaultTableModel(
            new Object[][] {
              {null, null},
              {null, null},
              {null, null},
              {null, null}
            },
            new String[] {"Nombre", "Propietario"}));
    tblListas.setSelectionBackground(new java.awt.Color(66, 58, 111));
    jScrollPane1.setViewportView(tblListas);

    panel2.add(jScrollPane1);
    jScrollPane1.setBounds(40, 270, 390, 110);

    lblTitle2.setFont(new java.awt.Font("Monospaced", 0, 20)); // NOI18N
    lblTitle2.setForeground(new java.awt.Color(53, 12, 87));
    lblTitle2.setText("Videos");
    panel2.add(lblTitle2);
    lblTitle2.setBounds(200, 30, 80, 20);
    panel2.add(jSeparator2);
    jSeparator2.setBounds(20, 60, 440, 10);

    tblVideos.setModel(
        new javax.swing.table.DefaultTableModel(
            new Object[][] {
              {null, null},
              {null, null},
              {null, null},
              {null, null}
            },
            new String[] {"Nombre", "Propietario"}));
    tblVideos.setSelectionBackground(new java.awt.Color(66, 58, 111));
    jScrollPane2.setViewportView(tblVideos);

    panel2.add(jScrollPane2);
    jScrollPane2.setBounds(40, 80, 390, 110);

    getContentPane().add(panel2);
    panel2.setBounds(30, 90, 480, 460);

    jPanel1.setBackground(new java.awt.Color(246, 246, 246));
    jPanel1.setLayout(null);

    jLabel9.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/logo.png"))); // NOI18N
    jPanel1.add(jLabel9);
    jLabel9.setBounds(460, 555, 30, 30);

    jLabel8.setFont(new java.awt.Font("Monospaced", 1, 12)); // NOI18N
    jLabel8.setForeground(new java.awt.Color(255, 255, 255));
    jLabel8.setText("UyTube");
    jPanel1.add(jLabel8);
    jLabel8.setBounds(490, 568, 49, 17);

    jLabel7.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/formBackground.jpg"))); // NOI18N
    jPanel1.add(jLabel7);
    jLabel7.setBounds(240, 370, 310, 230);

    lblTitle.setFont(new java.awt.Font("Monospaced", 0, 24)); // NOI18N
    lblTitle.setForeground(new java.awt.Color(53, 12, 87));
    lblTitle.setText("Consulta Categoria");
    jPanel1.add(lblTitle);
    lblTitle.setBounds(140, 30, 260, 33);

    getContentPane().add(jPanel1);
    jPanel1.setBounds(0, 0, 550, 600);

    setBounds(234, 78, 552, 620);
  } // </editor-fold>//GEN-END:initComponents

  private void cargarDatos() {
    ArrayList<DtVideoProp> videos =
        iCategoria.consultaCategoria(
            modeloCategorias.getValueAt(tblCategorias.getSelectedRow(), 0).toString());
    ArrayList<DtListaProp> listas =
        iCategoria.listarListas(
            modeloCategorias.getValueAt(tblCategorias.getSelectedRow(), 0).toString());
    for (DtVideoProp video : videos) {
      modeloVideos.addRow(new Object[] {video.getVideo(), video.getPropietario()});
    }
    for (DtListaProp lista : listas) {
      modeloListas.addRow(new Object[] {lista.getLista(), lista.getPropietario()});
    }
  }

  private void btnSiguienteMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnSiguienteMouseClicked
    if (btnSiguiente.isEnabled()) {
      panel1.setVisible(false);
      panel2.setVisible(true);
      cargarDatos();
    }
  } // GEN-LAST:event_btnSiguienteMouseClicked

  private void btnVolverMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnVolverMouseClicked
    panel1.setVisible(true);
    panel2.setVisible(false);
  } // GEN-LAST:event_btnVolverMouseClicked

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton btnSiguiente;
  private javax.swing.JButton btnVolver;
  private javax.swing.JLabel jLabel13;
  private javax.swing.JLabel jLabel16;
  private javax.swing.JLabel jLabel7;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JScrollPane jScrollPane2;
  private javax.swing.JScrollPane jScrollPane6;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JSeparator jSeparator15;
  private javax.swing.JSeparator jSeparator16;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JLabel lblTitle;
  private javax.swing.JLabel lblTitle1;
  private javax.swing.JLabel lblTitle2;
  private javax.swing.JPanel panel1;
  private javax.swing.JPanel panel2;
  private javax.swing.JTable tblCategorias;
  private javax.swing.JTable tblListas;
  private javax.swing.JTable tblVideos;
  private javax.swing.JTextField txtFindCategoria;
  // End of variables declaration//GEN-END:variables
}
